<template>
  <div class="ob-questionnaire-stats">
    <div :class="[ 'ob-questionnaire-stats-table', { 'simple': previewMode || countersDisabled } ]">
      <div
        v-if="!previewMode && fieldsDisabled && localPassingScore"
        class="ob-questionnaire-stats-table__passing-score"
      >
        Проходной балл <strong>{{ localPassingScore }}</strong>
      </div>

      <div
        v-if="!previewMode && !countersDisabled"
        class="ob-questionnaire-stats-table__header"
      >
        Максимально за анкету <span class="ob-questionnaire-stats-table__number">{{ totalPoints }}</span>
      </div>

      <div class="ob-questionnaire-stats-table__content">
        <div
          v-for="(group, i) in groups"
          :key="i"
          :class="[
            'ob-questionnaire-stats-table__row',
            { 'active': openedGroups.includes(group.uuid) && visibleGroup === group.uuid },
            { 'alternative': fillMode || previewMode }
          ]"
          :data-qa="dataQa"
          @click="onGroupClick(i, group)"
        >
          <div>
            {{ group.title }}
          </div>

          <i
            v-if="(fillMode || previewMode) && validGroups[i]"
            class="icon ob-questionnaire-stats-table__icon checked-simple"
          />

          <span v-if="!countersDisabled && !previewMode">
            {{ calculatedMaxPoints[i] }}
          </span>
        </div>
      </div>
    </div>

    <template v-if="!previewMode">
      <div
        v-if="!fieldsDisabled && !countersDisabled"
        class="passing-score"
      >
        <ObCheckbox
          v-model="isPassingScoreEnabled"
          label="Назначить проходной балл"
          :disabled="!totalPoints"
          @change="onPassingScoreStatusChanged"
        />

        <ObInput
          v-if="isPassingScoreEnabled"
          v-model="localPassingScore"
          :is-valid="!isShowPassingScoreWarning"
          placeholder="0"
          type="number:strict"
          class="passing-score__input"
          @input="onInputPassingScore"
          @blur="onBlurPassingScore"
        />
      </div>

      <ObAlert
        v-if="isPassingScoreEnabled && isShowPassingScoreWarning"
        text="Введите значение проходного балла"
        theme="danger-flat"
        icon="info"
        :hide-close-button="true"
      />

      <ObButton
        v-if="!countersDisabled"
        class="ob-questionnaire-stats__preview-button"
        label="Предварительный просмотр"
        type="flat"
        :data-qa="dataQa"
        @click="onPreviewClick"
      />
    </template>
  </div>
</template>

<script>
import QuestionnaireMixin from './questionnaireMixin'
import ObCheckbox from '../../obCheckbox'
import ObInput from '../../obInput'
import ObAlert from '../../obAlert'
import ObButton from '../../obButton'

export default {
  name: 'QuestionnaireStats',
  components: {
    ObCheckbox,
    ObInput,
    ObAlert,
    ObButton
  },
  mixins: [
    QuestionnaireMixin
  ],
  props: {
    previewMode: {
      type: Boolean,
      default: false
    },
    openedGroups: {
      type: Array,
      default: () => []
    },
    visibleGroup: {
      type: String,
      default: null
    },
    groups: {
      type: [ Array, null ],
      default: () => {
        return {
          sections: []
        }
      }
    },
    passingScore: {
      type: [ Number, null ],
      default: undefined
    }
  },
  data () {
    return {
      localPassingScore: 0,
      isPassingScoreEnabled: this.passingScore != null && this.passingScore >= 0,
      isShowPassingScoreWarning: false
    }
  },
  computed: {
    totalPoints () {
      if (!this.calculatedMaxPoints.length) {
        return 0
      }

      return this.calculatedMaxPoints.reduce((sum, item) => {
        return sum + item
      })
    },
    calculatedMaxPoints () {
      let points = this.groups

      return points.map((group) => {
        return group.questions.reduce((sum, question) => {
          // For user questions group
          if (!question.fields.length) {
            return 0
          }

          if (question.type === 'MULTISELECT') {
            return sum + question.fields.reduce((sum, field) => {
              return sum + Number(field.weight)
            }, 0)
          } else {
            return sum + Math.max.apply(Math, question.fields.map((field) => {
              return Number(field.weight)
            })) || 0
          }
        }, 0)
      })
    },
    validGroups () {
      const points = this.groups

      const validGroups = points.map((group) => {
        for (let i = 0; i < group.questions.length; i++) {
          switch (group.questions[i].type) {
            case 'TEXT':
              for (let j = 0; j < group.questions[i].fields.length; j++) {
                if (!group.questions[i].fields[j].value) {
                  return false
                }
              }

              break

            case 'MULTISELECT':
              let isAnyCheckboxSelected = false

              for (let j = 0; j < group.questions[i].fields.length; j++) {
                if (group.questions[i].fields[j].value) {
                  isAnyCheckboxSelected = true

                  break
                }
              }

              if (!isAnyCheckboxSelected) {
                return false
              }

              break

            default:
              if (!group.questions[i].selected) {
                return false
              }

              break
          }
        }

        return true
      })

      this.$emit('state-changed', validGroups.every((group) => {
        return group
      }))

      return validGroups
    }
  },
  watch: {
    passingScore: {
      handler (value) {
        this.localPassingScore = value
      },
      immediate: true
    },
    totalPoints (value) {
      if (!this.isPassingScoreEnabled) {
        return
      }

      if (!value) {
        this.isPassingScoreEnabled = false

        this.onPassingScoreStatusChanged(false)
      } else if (value < this.localPassingScore) {
        this.localPassingScore = value

        this.onBlurPassingScore()
      }
    }
  },
  mounted () {
    this.checkState()
  },
  methods: {
    onGroupClick (index, group) {
      this.$emit('open-group', { index, group })
    },
    onPreviewClick () {
      this.$emit('toggle-preview')
    },
    checkState () {
      // Set questionnaire state on init
      this.$emit('set-state', this.validGroups.every((group) => {
        return group
      }))
    },
    onPassingScoreStatusChanged (isEnabled) {
      if (!isEnabled) {
        this.isShowPassingScoreWarning = false
      }

      this.$emit('passing-score-status-changed', isEnabled)
    },
    onInputPassingScore (value) {
      // Passing score cannot be more that 'totalPoints' number
      if (Number(value) > this.totalPoints) {
        this.$nextTick().then(() => {
          this.localPassingScore = this.totalPoints
        })
      }
    },
    onBlurPassingScore () {
      const value = Number(this.localPassingScore)

      this.isShowPassingScoreWarning = !value

      if (value) {
        this.$emit('passing-score-changed', value)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../../../assets/style/ob-style';
  @import '../../../static/css/variables';

  .ob-questionnaire-stats {
    &:not(:last-child) {
      margin-bottom: 40px;
    }

    &__preview-button {
      margin: 40px auto 0;
    }
  }

  .ob-questionnaire-stats-table {
    &:not(.simple) {
      border: 1px solid $lavender;
      margin-bottom: 11px;
    }

    &__header {
      font-size: 16px;
      display: flex;
      justify-content: space-between;
      border-bottom: 1px solid $lavender;
      padding: 15px 20px 11px;
    }

    &__passing-score {
      @include font-mixin(16px, 20px, 400, $color-text-base);

      display: flex;
      justify-content: space-between;
      background-color: rgba($Green-500, .05);
      padding: 14px 20px;
    }

    &__number {
      font-size: 24px;
      font-weight: bold;
    }

    &__content {
      padding: 20px;
      display: grid;
      grid-gap: 14px;
    }

    &__row {
      $text-color-active: $color-blue-navy-blue;

      display: grid;
      grid-auto-flow: column;
      grid-template-columns: 1fr;
      grid-gap: 20px;
      align-items: center;
      line-height: 18px;
      position: relative;
      cursor: pointer;

      &.alternative {
        color: $color-grey-label;
      }

      &:hover {
        color: $text-color-active;
      }

      &.active {
        color: $text-color-active;

        &::before {
          position: absolute;
          top: -3px;
          left: -10px;
          height: calc(100% + 4px);
          width: 2px;
          content: '';
          background-color: $text-color-active;
        }
      }
    }

    &__icon {
      font-size: 10px;
      color: $color-grey-span;
    }

    &.simple &__content {
      padding: 0;
    }
  }

  .passing-score {
    display: grid;
    grid-auto-flow: column;
    grid-column-gap: 17px;
    align-items: center;
    justify-content: space-between;
    padding: 0 8px 0 5px;
    height: 30px; // Same as ObInput to prevent content flicking
    margin-bottom: 10px;

    &__input {
      width: 64px;

      &::v-deep {
        .ob-input-wrap {
          height: 30px;
          padding: 7px 12px 3px;
        }

        .input {
          text-align: right;
        }

        .main-icon {
          display: none;
        }
      }
    }
  }
</style>
